<?php
/**
 * Functions for displaying notices in the admin
 * @since 2.0.0
 * @package Bookings for WooCommerce
 */

// Exit if accessed directly
if( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Check for admin notices
 * @since 2.0.0
 */
function bfwc_admin_notices() {
	if( isset( $_GET['sync_cal'] ) ) {
		add_action( 'admin_notices', 'bfwc_calendars_synced_notice' );
	}
}
add_action( 'admin_init', 'bfwc_admin_notices' );

/**
 * Display a notice when calendars have been synced
 * @since 2.0.0
 */
function bfwc_calendars_synced_notice() { ?>
	<div class="notice notice-success">
		<p>
			<?php _e( 'Your external calendars have been synced.', 'bfwc' ); ?>
		</p>
	</div>
<?php }