<?php
/**
 * The template for the edit booking field in orders
 * @since 1.4.0
 * @package Bookings for WooCommerce
 */

// Exit if accessed directly
if( ! defined( 'ABSPATH' ) ) {
	exit;
} ?>

<div class="booking_data_column">
	<h3>
		<?php esc_html_e( 'Order details', 'woocommerce' ); ?>
	</h3>
	<div class="order">

		<?php if( $order_id ) {
			if ( ! is_a( $order, 'WC_Order' ) ) {
				$order = wc_get_order( $order_id );
			}
			//$url = admin_url( 'post.php?post=' . $order_id . '&action=edit' );
			$url = $order->get_edit_order_url(); // WC HPOS compatibility
			printf(
				'%s&nbsp;<a href="%s">%s</a>',
				__( 'Order', 'bfwc' ),
				$url,
				'#' . $order_id
			);

			//$payment_link = get_post_meta( $order_id, 'bfwc_payment_link', true );
			$payment_link = $order->get_meta( 'bfwc_payment_link', true ); // WC HPOS
			if( $payment_link ) {
				printf(
					'<p><a href="%s">%s</a></p>',
					esc_url( $payment_link ),
					__( 'Customer payment page', 'bfwc' )
				);
			} ?>

		<?php } else if( isset( $_GET['action'] ) && $_GET['action'] == 'edit' ) {

			// Only show this option when the booking has been created

			$order_url = add_query_arg(
				array(
					'action'				=> 'edit',
					'post'					=> $booking_id,
					'create_order'	=> 'true'
				),
				admin_url( 'post.php' )
			);
			printf(
				'<p><a class="button secondary-button" href="%s">%s</a></p>',
				esc_url( $order_url ),
				__( 'Create order', 'bfwc' )
			);

		} else {

			printf(
				'<p>%s</p>',
				__( 'You can create an order for this booking once the booking is published', 'bfwc' )
			);

		} ?>
	</div>
</div>
