(function($) {
	$(document).ready(function(){

		$( '.bfwc_select2' ).select2();

		/* Menu navigation */
		$( '.bfwc-menu-item a' ).on( 'click', function( e ) {
			e.preventDefault();
			$( '.bfwc-menu-item' ).removeClass( 'active' );
			$( '.bfwc_options_group' ).removeClass( 'active' );
			var item = $( this ).closest( 'li' ).data( 'id' );
			
			$( '.bfwc_' + item ).addClass( 'active' );
			$( this ).closest( 'li' ).addClass( 'active' );
		});
		
		var unit = $('select#_booking_unit').val();
		$('#booking_options').addClass('bfwc-'+unit);
		$('select#_booking_unit').on('change',function(){
			var panel = $(this).closest( '.panel' );
			$(panel).removeClass (function (index, className) {
		    return (className.match (/(^|\s)bfwc-\S+/g) || []).join(' ');
			});
			$(panel).addClass('bfwc-'+$(this).val());
		});
		$('body').on('focus','.bfwc-start-date',function(){
			$(this).datepicker({
				dateFormat: bfwc_params.date_format,
				firstDay: 0,
				dayNamesMin: [ "Su", "Mo", "Tu", "We", "Th", "Fr", "Sa" ],
				beforeShowDay: check_start_day,
				onSelect: function( dateText, inst ) {
					var date = $(this).val();
					var start = $(this).datepicker('getDate');
					var ymd_start = calendar.get_ymd( start );
					$(this).parent().find('.non-std-start-date-ymd').val(ymd_start);
					if( $( this ).hasClass( 'bfwc-last-date' ) ) {
						$( '#_last_date_ymd' ).val( ymd_start );
					}
				}
			});
		});
		$('body').on('focus','.bfwc-end-date',function(){
			// Get start date for this range
			var row = $(this).parent().parent();
			var start = $(row).find('.bfwc-start-date');
			var start_date = $(start).val();
			$(this).datepicker({
				dateFormat: bfwc_params.date_format,
				firstDay: 0,
				minDate: start_date,
				dayNamesMin: [ "Su", "Mo", "Tu", "We", "Th", "Fr", "Sa" ],
				beforeShowDay: check_end_day,
				onSelect: function( dateText, inst ) {
					var date = $(this).val();
					var end = $(this).datepicker('getDate');
					var ymd_end = calendar.get_ymd( end );
					$(this).parent().find('.non-std-end-date-ymd').val(ymd_end);
				}
			});
		});
		$('body').on('click','.add_new_row',function(e){
			e.preventDefault();
			var last_row = $('.non-std-data').find('tr').last();
			var count = $(last_row).attr('data-count');
			if( isNaN( count ) ) count = -1;
			count = parseFloat( count ) + 1;
			var clone_row = $('.new-data-row').clone().appendTo('#data_rows');
			$(clone_row).removeClass('new-data-row');
			$(clone_row).attr('data-count',count);
			$(clone_row).find('.non-std-start-date').attr('name','_nonstd_data[' + count + '][start_date]');
			$(clone_row).find('.non-std-start-date-ymd').attr('name','_nonstd_data[' + count + '][start_date_ymd]');
			$(clone_row).find('.non-std-end-date').attr('name','_nonstd_data[' + count + '][end_date]');
			$(clone_row).find('.non-std-end-date-ymd').attr('name','_nonstd_data[' + count + '][end_date_ymd]');
			$(clone_row).find('.non-std-num-units').attr('name','_nonstd_data[' + count + '][num_units]');
			$(clone_row).find('.non-std-cost').attr('name','_nonstd_data[' + count + '][cost]');
		});
		$('body').on('click','.remove',function(e){
			e.preventDefault;
			var table = $( this ).closest( 'table' );
			$( table ).block( {
				message: null,
				overlayCSS: {
					background: '#fff',
					opacity: 0.6
				}
			});
			$(this).parent().fadeOut(
				150,
				function() {
					$(this).remove();
					// Restore original availability
					var start_date = $( this ).closest( 'tr' ).find( '.non-std-start-date-ymd' ).val();
					var end_date = $( this ).closest( 'tr' ).find( '.non-std-end-date-ymd' ).val();
					$.ajax({
						type: 'POST',
						url: ajaxurl,
						data: {
							action: 'bfwc_restore_availability',
							start_date: start_date,
							end_date: end_date,
							product_id: $( '#post_ID' ).val(),
							security: $( '#bfwc_nonstd_nonce' ).val()
						},
						success: function( response ) {
							$( table ).unblock();
						}
					});
				}
			);
		});
		$('#data_rows').sortable({handle:'.sort-handle'});
		function check_start_day( date ) {
			if ( bfwc_params.enable_all_dates_non_standard_costs == 'yes' && $(this).hasClass( 'non-std-start-date' ) ) {
				return [true,''];
			}
			var start_day = $('#_bookings_start').val();
			if( ! start_day || start_day == 99 ) {
				return [true,''];
			}
			var d = new Date( date );
			// If date is start day
			if( start_day == d.getDay() ) {
				return [true,''];
			}
			return [false, 'disabled'];
		}
		function check_end_day( date ) {
			if ( bfwc_params.enable_all_dates_non_standard_costs == 'yes' && $(this).hasClass( 'non-std-end-date' ) ) {
				return [true,''];
			}
			var start_day = $('#_bookings_start').val();
			if( ! start_day || start_day == 99 ) {
				return [true,''];
			}
			var d = new Date( date );
			var end_day = d.getDay();
			end_day++;
			if( end_day > 6 ) end_day = 0;
			// If date is start day
			if( start_day == end_day ) {
				return [true,''];
			}
			return [false, 'disabled'];
		}

		// Admin calendar
		$( '#bfwc-datepicker' ).datepicker({
			disabled: false,
			firstDay: 0,
			dayNamesMin: [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ], // @todo
			onSelect: function( date ) {
				$( '#bfwc-calendar-modal' ).block({
					message: null,
					overlayCSS:  {
						backgroundColor: '#fff',
						opacity:         0.6,
						cursor:          'wait'
					},
				});

				// Pull data for this day in to a modal window
				$.ajax({
					type: 'POST',
					url: ajaxurl,
					data: {
						action: 'bfwc_get_booking_data',
						date: date,
						product_id: $( '#post_ID' ).val(),
						security: $( '#bfwc_calendar_modal_nonce' ).val()
					},
					success: function( response ) {
						$( '#bfwc-calendar-modal' ).unblock();

						var html = '<div class="bfwc-calendar-modal-inner">';
						html += '<h2>' + response.date + '</h2>';

						if( response.availability ) {
							html += '<p>' + response.availability + '</p>';
						}

						$( '#bfwc_selected_date' ).val( date );

						if( response.booking_data  ) {
							// Iterate through each booking on this date for this product

							html += '<div class="booking-data-wrapper"';

							var booking_data = response.booking_data;

							if( booking_data.length > 0 ) {

								html += '<div class="booking-data">';
								html += '<table><thead>';

								html += '<th>Booking ID</th>';
								html += '<th>Order ID</th>';
								html += '<th>Start</th>';
								html += '<th>End</th>';
								html += '<th>Customer</th>';

								html += '</thead>';
								html += '<tbody>';
								
								booking_data.forEach( function( item, index ) {

									html += '<tr>';

									html += '<td><a href="' + item.booking_url + '">&#x23;' + item.id + '</a></td>';

									// 2.0.5
									if ( item.order_url != '' ) {
										html += '<td><a href="' + item.order_url + '">&#x23;' + item.order_id + '</a></td>';
									} else {
										html += '<td>&nbsp;</td>';
									}

									html += '<td>' + item.start + '</td>';
									html += '<td>' + item.end + '</td>';

									if ( item.user_url != '' ) {
										html += '<td><a href="' + item.user_url + '">' + item.user_name + '</a></td>';
									} else {
										html += '<td>' + item.user_name + '</td>';
									}

									html += '</tr>';
									
								});

								html += '</tbody>';
								html += '</table>';
								html += '</div>';

							}

						}

						html += '</div>';

						$( '#bfwc-calendar-modal' ).html( html );
					}
				});

				$( 'body' ).on( 'click', '.bfwc-edit-availability', function( e ) {
					e.preventDefault();
					$.ajax({
						type: 'POST',
						url: ajaxurl,
						data: {
							action: 'bfwc_edit_availability',
							date: $( '#bfwc_selected_date' ).val(),
							product_id: $( '#post_ID' ).val(),
							security: $( '#bfwc_calendar_modal_nonce' ).val()
						},
						success: function( response ) {
							console.log( 'edit availability', response );
						}
					});
				});

			},
			beforeShowDay: function( date ){
				var params = calendar.before_show_day_start( date );
				// Dates always need to be enabled in order to get further info
				params[0] = 'true';
				return params;
			},
		});

		$( '#bfwc_start_date_text_edit' ).datepicker({
			// disabled: true,
			firstDay: 0,
			dayNamesMin: [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ],
			dateFormat: 'yy-mm-dd',
			beforeShowDay: function( date ) {
				var params = calendar.before_show_day_start( date );
				return params;
			},
			onSelect: function( dateText, inst ) {
				$( '#bfwc_start_date_text_edit' ).datepicker( 'option', 'dateFormat', bfwc_params.date_format ).val();
				// Compare start and end dates
				compare_start = $('#bfwc_start_date_text_edit').datepicker('getDate');
				compare_end = $('#bfwc_end_date_text_edit').datepicker('getDate');
				ymd_start = calendar.get_ymd( compare_start );
				ymd_end = calendar.get_ymd( compare_end );
				$( '#start_date_ymd' ).val( ymd_start );
				$(' #bfwc_end_date_text_edit ').val( '' );
				$( '#end_date_ymd' ).val( '' );

				$( '#bfwc_end_date_text_edit' ).attr( 'disabled', false );

				$('#bfwc_end_date_text_edit').datepicker({
					dateFormat: 'yy-mm-dd',
					minDate: compare_start,
					// maxDate: max_date,
					firstDay: 0,
					dayNamesMin: [ "Su", "Mo", "Tu", "We", "Th", "Fr", "Sa" ],
					beforeShowDay: function( date ) {
						var params = calendar.before_show_day_end( date );
						return params;
					},
					onSelect: function( dateText, inst ) {
						// update_cost();
						$( '.edit-end-date' ).show();
						$( '#bfwc_end_date_text_edit' ).datepicker( 'option', 'dateFormat', bfwc_params.date_format ).val();

						compare_end = $('#bfwc_end_date_text_edit').datepicker('getDate');
						ymd_end = calendar.get_ymd( compare_end );
						$( '#end_date_ymd' ).val( ymd_end );

						var table = $( this ).closest( 'table' );
						$( table ).block({
							message: null,
							overlayCSS: {
								background: '#fff',
								opacity: 0.6
							}
						});

						// We need to establish the product ID
						var product_id = false;
						if( $( '#bfwc_product_id' ).length ) {
							// From a booking page
							product_id = $( '#bfwc_product_id' ).val();
						} else if( $( '#bfwc_product_id' ).length ) {
							// From a product page
							product_id = $( '#post_ID' ).val();
						}

						// Get max available units for new date range
						$.ajax({
							type: 'POST',
							url: ajaxurl,
							data: {
								action: 'bfwc_get_availability_by_range',
								start_date: $( '#bfwc_start_date_text_edit' ).val(),
								end_date: $( '#bfwc_end_date_text_edit' ).val(),
								start_date_ymd: $( '#start_date_ymd' ).val(),
								end_date_ymd: $( '#end_date_ymd' ).val(),
								product_id: product_id,
								booking_id: $( '#bfwc_booking_id' ).val(),
								security: $( '#bfwc_edit_booking' ).val()
							},
							success: function( response ) {
								$( table ).unblock();
								$( '#bfwc_num_bookings_edit' ).attr( 'disabled', false );
								var current_num = $( '#bfwc_num_bookings_edit' ).val();
								var available = response.available;
								if( available < current_num ) {
									$( '#bfwc_num_bookings_edit' ).val( available );
								} else if( ! current_num ) {
									$( '#bfwc_num_bookings_edit' ).val( 1 );
								}
								$( '#bfwc_num_bookings_edit' ).attr( 'max', available );
								$( '.bfwc-save-booking' ).removeClass( 'disabled' ).addClass( 'enabled' );
							}
						});
					}
				});
			}
		});

		var edit_booking = {

			init: function() {
				$( 'body' ).on( 'click', '.bfwc-edit-booking', this.edit );
				$( 'body' ).on( 'click', '.bfwc-save-booking.disabled', this.prevent_save );
				// $( 'body' ).on( 'click', '.bfwc-save-booking.enabled', this.save );
				$( 'body' ).on( 'click', '.bfwc-cancel-update', this.cancel );
				$( 'body' ).on( 'select2:select', '#bfwc_product_id_select', this.add_product );
			},

			prevent_save: function( e ) {
				e.preventDefault();
			},

			edit: function( e ) {
				e.preventDefault();
				$( this ).hide();
				var section = $( '.bfwc-booking-details-order' );
				$( section ).addClass( 'editing' );
				$( section ).find( '.edit' ).show();

				var table = $( '.bfwc-booking-details-order' );
				$( table ).block( {
					message: null,
					overlayCSS: {
						background: '#fff',
						opacity: 0.6
					}
		   		});

				// We need to establish the product ID
				var product_id = edit_booking.get_product_id();

				$.ajax({
					type: 'POST',
					url: ajaxurl,
					data: {
						action: 'bfwc_edit_booking',
						booking_id: $( '#bfwc_booking_id' ).val(),
						start_date: $( '#start_date_ymd' ).val(),
						end_date: $( '#end_date_ymd' ).val(),
						original_start_date: $( '#original_start_date_ymd' ).val(),
						original_end_date: $( '#original_end_date_ymd' ).val(),
						start_date_text: $( '#bfwc_start_date_text_edit' ).val(),
						end_date_text: $( '#bfwc_end_date_text_edit' ).val(),
						quantity: $( '#bfwc_num_bookings_edit' ).val(),
						original_quantity: $( '#bfwc_original_num_bookings' ).val(),
						product_id: product_id,
						security: $( '#bfwc_save_booking' ).val()
					},
					success: function( response ) {
						bfwc_availability = response.availability;
						$( '#bfwc-start-date-td' ).text( $('#bfwc_start_date_text_edit').val() );
						$( '#bfwc-end-date-td' ).text( $('#bfwc_end_date_text_edit').val() );
						$( '#bfwc-num-bookings-td' ).text( $('#bfwc_num_bookings_edit').val() );
						$( table ).unblock();
					}
				});
			},

			cancel: function( e ) {

				e.preventDefault();

				// If we cancel the edit, we need to un-restore the original booking dates
				var table = $( '.bfwc-booking-details-order' );
				$( table ).block( {
		      message: null,
		      overlayCSS: {
		        background: '#fff',
		        opacity: 0.6
		      }
		    });

				// We need to establish the product ID
				var product_id = edit_booking.get_product_id();

				$.ajax({
					type: 'POST',
					url: ajaxurl,
					data: {
						action: 'bfwc_cancel_editing_booking',
						booking_id: $( '#bfwc_booking_id' ).val(),
						start_date: $( '#start_date_ymd' ).val(),
						end_date: $( '#end_date_ymd' ).val(),
						original_start_date: $( '#original_start_date_ymd' ).val(),
						original_end_date: $( '#original_end_date_ymd' ).val(),
						start_date_text: $( '#bfwc_start_date_text_edit' ).val(),
						end_date_text: $( '#bfwc_end_date_text_edit' ).val(),
						quantity: $( '#bfwc_num_bookings_edit' ).val(),
						original_quantity: $( '#bfwc_original_num_bookings' ).val(),
						product_id: product_id,
						security: $( '#bfwc_save_booking' ).val()
					},
					success: function( response ) {
						$( '#bfwc-start-date-td' ).text( $('#bfwc_start_date_text_edit').val() );
						$( '#bfwc-end-date-td' ).text( $('#bfwc_end_date_text_edit').val() );
						$( '#bfwc-num-bookings-td' ).text( $('#bfwc_num_bookings_edit').val() );
						// edit_booking.reset_buttons();

						// Update bfwc_availability



						$( table ).unblock();
						// Reload
						// location.reload();
					}
				});

				edit_booking.reset_buttons();
			},

			reset_buttons: function() {
				var section = $( '.bfwc-booking-details-order' );
				$( section ).removeClass( 'editing' );
				$( section ).find( '.edit' ).hide();
				$( '.bfwc-save-booking' ).addClass( 'disabled' );
				$( '#bfwc_end_date_text_edit' ).prop( 'disabled', true );
				$( '#bfwc_num_bookings_edit' ).prop( 'disabled', true );
				$( '.bfwc-edit-booking' ).show();
			},

			add_product: function( e ) {
				var product_id = $( this ).val();
				$( '#bfwc_product_id' ).val( product_id );
				var section = $( '.bfwc-booking-details-order' );
				$( section ).block( {
		      message: null,
		      overlayCSS: {
		        background: '#fff',
		        opacity: 0.6
		      }
		    });
				// Update bfwc_availability variable with data for newly added product ID
				$.ajax({
					type: 'POST',
					url: ajaxurl,
					data: {
						action: 'bfwc_get_availability_per_day_new_booking',
						product_id: product_id,
						security: $( '#bfwc_add_product_new_booking' ).val()
					},
					success: function( response ) {
						$( section ).unblock();
						if( response.data.availability ) {
							bfwc_availability = response.data.availability;
						}
						if( response.data.max_bookings ) {
							$( '#_max_bookings' ).val( response.data.max_bookings );
						}
						// Reload
						// location.reload();
					}
				});

				// Open the other fields for editing
				edit_booking.edit( e );
			},

			get_product_id: function() {

				var product_id = false;
				if( $( '#bfwc_product_id' ).length ) {
					// From a booking page
					product_id = $( '#bfwc_product_id' ).val();
				} else if( $( '#bfwc_product_id' ).length ) {
					// From a product page
					product_id = $( '#post_ID' ).val();
				}
				return product_id;

			}

		}

		edit_booking.init();

	});

	var calendar = {

		before_show_day_start: function( date ) {

			// Use this to return true/false
			var day_availability = true;

			var is_available = calendar.is_day_available( date, 1, '', 0, false );

			// Disable dates in the past
			day_availability = calendar.is_day_before_today( date );

			var class_name = ' ' + is_available[1];

			var max_bookings = $( '#_max_bookings' ).val();

			if( ! max_bookings ) max_bookings = 1;

			var ymd = calendar.get_ymd( date );
			var title = '';
			var blocked = bfwc_params.blocked;

			if( day_availability ) {
				// Add price for daily and overnight products
				if( calendar.get_date_price( ymd ) ) {
					calendar.add_extra_data( ymd, 'price', calendar.get_date_price( ymd ) );
				}
			}

			if( ! day_availability ) {

				title += '-';
				class_name += ' past';

			} else if( ( bfwc_availability[ymd] || bfwc_availability[ymd] === 0 ) ) {

				console.log( ymd, bfwc_availability[ymd] );

				title += bfwc_availability[ymd] + ' ' + bfwc_params.available_text;
				if( bfwc_availability[ymd] >= max_bookings ) {
					class_name += ' fully-available';
				} else if( bfwc_availability[ymd] == 0 ) {
					// Weekly bookings are slightly different
						// Need to ensure that the last date of a weekly booking is available for the start of a new one
						if( bfwc_params.booking_unit == 'week' && bfwc_params.bookings_unavailable.indexOf( ymd ) == -1 ) {
							// The availability can show 0 but the date might not be present in the bookings_unavailable parameter
							// If this is the case, it's the last day of a weekly booking and therefore is available for the start of a new booking
							class_name += ' fully-available start-new-weekly';
						} else {
							class_name += ' unavailable';
							day_availability = false;
						}
				} else {
					class_name += ' part-available';
				}
			} else {
				title += max_bookings + ' ' + bfwc_params.available_text;
				class_name += ' fully-available';
			}

			class_name += ' date-' + ymd;

			return [day_availability, class_name, title];

		},

		before_show_day_end: function( date ) {

			// Use this to return true/false
			var day_availability = true;

			// Otherwise, add the number of available units per date
			var is_available = calendar.is_day_available( date, bfwc_params.bookings_start, '', 0, false );

			// Disable dates in the past
			day_availability = calendar.is_day_before_today( date );

			var class_name = ' ' + is_available[1];

			var max_bookings = $( '#_max_bookings' ).val();

			if( ! max_bookings ) max_bookings = 1;

			var ymd = calendar.get_ymd( date );
			var title = '';
			var blocked = bfwc_params.blocked;

			if( day_availability ) {
				// Add price
				calendar.add_extra_data( ymd, 'price', calendar.get_date_price( ymd ) );
			}

			if( ! day_availability ) {

				title += '-';
				class_name += ' past';

			} else if( bfwc_availability[ymd] || bfwc_availability[ymd] === 0 ) {
				title = bfwc_availability[ymd] + ' ' + bfwc_params.availability_text;
				if( bfwc_availability[ymd] >= max_bookings ) {
					class_name += ' fully-available';
				} else if( bfwc_availability[ymd] == 0 ) {
					class_name += ' unavailable';
					day_availability = false;
				} else {
					class_name += ' part-available';
				}
			} else {
				title += max_bookings + ' ' + bfwc_params.availability_text;
				class_name += ' fully-available';
			}

			class_name += ' date-' + ymd;
			if( date < compare_start ) {
				class_name += ' past';
				day_availability = false;
			}

			return [day_availability, class_name, title];

		},

		/**
		 * @param date				Date
		 * @param permitted_day 	Specific day of the week that can be selected
		 * @param next_date			Start of next booking. Added 1.1.4
		 * @param min_date			Minimum start date for the calendar, formatted like 2018-02-23
		 * @param is_end			true if the end date calendar has triggered
		 */
		is_day_available: function( date, permitted_day, next_date, min_date, is_end ) {

			// Get a date object for the min_date parameter
			if( min_date ) {
				min_date = min_date.split( '-' );
				var min_date_obj = new Date( min_date[0], min_date[1]-1, min_date[2] );
			}

			var d = new Date( date );
			var next_d = new Date( next_date );

			if( Date.parse( next_d ) > 0 ) { // Confirm we have a valid date
				if( d > next_d ) {
					return [false, 'booked']; // We can't book through existing or blocked bookings
				}
			}

			// Use valueOf to compare dates
			if( min_date_obj ) {
				if( d.valueOf() == min_date_obj.valueOf() ) {
					// Return true for minimum bookable date
					return [true,''];
				}
			}

			// Convert date to YYYY-MM-DD format
			var month = '0' + ( d.getMonth() + 1 );
			day = d.getDate();
			// If the booking is overnight and overlaps are permitted and we're looking for the end date, push the available date back by one day
			// This addresses a bug where we couldn't allow a booking to finish on the same day another booking started
			if( is_end && bfwc_params.allow_overlaps == 'yes' && bfwc_params.booking_unit == 'night' ) {
				day++;
			}
			var day = '0' + ( day );
			var check_date = d.getFullYear() + '-' + month.substr( -2, 2 ) + '-' + day.substr( -2, 2 );

			// If date is in the unavailable list
			if( bfwc_params.bookings_unavailable.indexOf( check_date ) != -1 ) {
				return [false,'booked'];
			}

			// If start day is any day
			if( permitted_day == 99 ) {
				return [true,''];
			}
			// If date is start day
			if( permitted_day == d.getDay() ) {
				return [true,''];
			}
			return [false, 'disabled'];

		},

		is_day_before_today: function( date ) {

			// Use valueOf to compare dates
			var today = new Date();
			today.setHours( 0, 0, 0, 0 );
			var day = new Date( date );
			day.setHours( 23, 59, 59, 999 );

			if( day.valueOf() < today.valueOf() ) {
				// date is not before today
				return false;
			} else {
				return true;
			}

		},

		get_ymd: function( date ) {
			var d = new Date( date );
			var month = '0' + ( d.getMonth() + 1 );
			var day = '0' + ( d.getDate() );
			var ymd_date = d.getFullYear() + '-' + month.substr( -2, 2 ) + '-' + day.substr( -2, 2 );
			return ymd_date;
		},

		add_extra_data: function( date, attribute, value ) {
		  setTimeout (function() {
		    $( ".ui-datepicker-calendar td.date-" + date ).find( '.ui-state-default' ).attr( 'data-' + attribute, value );
		  }, 0 );
		},

		get_date_price: function( date ) {
			if( bfwc_params.booking_unit == 'week' ) {
				return false;
			}
			var prices = bfwc_params.prices;
			if( ! prices[date] ) {
				return bfwc_params.std_cost;
			}
			return prices[date];
		},

	};

	var global_calendar = {

		before_show_day: function( date ) {

			var ymd = calendar.get_ymd( date );
			var day_availability = global_calendar.get_global_day_availability( ymd );
			var class_name;
			if( ! calendar.is_day_before_today( date ) ) {
				class_name += ' past';
			} else {
				class_name = ' ' + day_availability[1];
			}
			var title = '';
			class_name += ' date-' + ymd;
			return [day_availability, class_name, title];

		},

		get_global_day_availability: function( date ) {

			if( bfwc_global_availability_status[date] ) {
				return [ true, bfwc_global_availability_status[date] ];
			}
			return [ true, 'fully-available' ];

		},

		// Add extra content for each date to data attributes
		update_data: function() {

			var timer = setTimeout(
				
				function() {

					for( var i in bfwc_monthly_data ) {

						var day = $( 'body' ).find( '.date-' + i ).find( 'a' ).text();
						var day_data = bfwc_monthly_data[i];
						var num_bookings = day_data.num_bookings;
						var content = day + '<span>' + num_bookings;
						if( ! num_bookings || num_bookings < 1 ) { 
							content = day;
						} else if( num_bookings == 1 ) {
							content += '&nbsp;booking</span>';
						} else {
							content += '&nbsp;bookings</span>';
						}
						$( 'body' ).find( '.date-' + i ).find( 'a' ).html( content );

					}

				},
				10

			);
		},

	};

	global_calendar.update_data();

	var notes = {

		init: function() {
			$( 'body' ).on( 'click', '#bfwc-add-note', this.add );
		},

		add: function( e ) {
			e.preventDefault();
			var notes = $( '#bfwc_notes_metabox' );
			var message = $( '#bfwc-note-message' ).val();
			if( ! message ) {
				return;
			}
			$( notes ).block( {
	      message: null,
	      overlayCSS: {
	        background: '#fff',
	        opacity: 0.6
	      }
	    });
			$.ajax({
				type: 'POST',
				url: ajaxurl,
				data: {
					action: 'bfwc_add_new_note',
					message: message,
					booking_id: $( '#bfwc_booking_id' ).val(),
					security: $( '#bfwc_add_note' ).val()
				},
				success: function( response ) {
					$( notes ).unblock();
					$( '.booking-notes' ).prepend(
						'<li rel="' + response.note_id + '" class="note system-note"><div class="note_content">' + response.message + '</div><p class="meta">' + response.date + '</p></li>'
					);
					$( '#bfwc-note-message' ).val( '' );
				}
			});
		}

	};

	notes.init();

	// Global calendar
	$( '#bfwc-global-datepicker' ).datepicker({
		disabled: false,
		firstDay: 0,
		dayNamesMin: [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ], // Need to update this as per front end @todo
		onSelect: function( date ) {
			global_calendar.update_data();
			$( '#bfwc-calendar-modal' ).block({
				message: null,
				overlayCSS:  {
					backgroundColor: '#fff',
					opacity:         0.6,
					cursor:          'wait'
				},
			});
			// Pull data for this day in to a modal window
			$.ajax({
				type: 'POST',
				url: ajaxurl,
				data: {
					action: 'bfwc_get_global_booking_data',
					date: date,
					security: $( '#bfwc_calendar_modal_nonce' ).val()
				},
				success: function( response ) {
					var used_bookings = response.used;
					$( '#bfwc-calendar-modal' ).unblock();

					var html = '<div class="bfwc-calendar-modal-inner">';
					html += '<h2>' + response.date + '</h2>';
					html += '<div class="booking-data">';
					html += '<h3>' + bfwc_params.availability_text + '</h3>';

					if( response.availability ) {
						html += '<table class="bfwc-availability-table"><thead>';
						html += '<th>' + bfwc_params.product_text + '</th>';
						html += '<th>' + bfwc_params.availability_text + '</th>';
						html += '<th>&nbsp;</th>';
						html += '</thead>';
						html += '<tbody>';
						var availability_data = response.availability;
						for( var i in availability_data ) {	
							var max = bfwc_max_bookings[i];
							var num = 0;
							var used = 100;
							if( used_bookings[i] ) {
								num = used_bookings[i];
							}
							if( num > 0 ) {
								used = 100 - ( ( num / max ) * 100 );
							}
							html += '<tr>';
							var product_url = bfwc_params.product_url_base;
							var title = bfwc_bookable_products[i];
							html += '<td><a href="' + product_url + '&post=' + i + '">' + title + '&nbsp;(&#x23;' + i + ')</a></td>';
							html += '<td>' + availability_data[i] + '</td>';
							html += '<td class="progress-bar"><div class="progress-outer"><span data-width="' + used + '" class="progress-inner"></span></div></td>';
							html += '</tr>';
						}
						html += '</tbody>';
						html += '</table>';
					} else {
						// No data message
						html += '<p>' + bfwc_params.no_availability_text + '</p>';
					}

					html += '</div>';

					$( '#bfwc_selected_date' ).val( date );

					if( response.booking_data ) {
						// Iterate through each booking on this date for this product

						html += '<div class="booking-data-wrapper">';
						html += '<h3>' + bfwc_params.bookings_text + '</h3>';
						var booking_data = response.booking_data;

						if( booking_data.length == undefined || booking_data.length > 0 ) {

							html += '<table>';
							html += '<thead>';

							html += '<th>Booking ID</th>';
							html += '<th>Product ID</th>';
							html += '<th>Order ID</th>';
							html += '<th>Start</th>';
							html += '<th>End</th>';
							html += '<th>Customer</th>';

							html += '</thead>';
							html += '<tbody>';

							for( var i in booking_data ) {

								var booking = booking_data[i];
								for( var k in booking ) {

									html += '<tr>';
									var item = booking[k];						
	
									html += '<td><a href="' + item.booking_url + '">&#x23;' + item.id + '</a></td>';
									html += '<td><a href="' + item.product_url + '">&#x23;' + i + '</a></td>';

									// 2.0.5
									if ( item.order_url != '' ) {
										html += '<td><a href="' + item.order_url + '">&#x23;' + item.order_id + '</a></td>';
									} else {
										html += '<td>&nbsp;</td>';
									}

									html += '<td>' + item.start + '</td>';
									html += '<td>' + item.end + '</td>';

									if ( item.user_url != '' ) {
										html += '<td><a href="' + item.user_url + '">' + item.user_name + '</a></td>';
									} else {
										html += '<td>' + item.user_name + '</td>';
									}

									html += '</tr>';
										
								}
								

							}

							html += '</tbody>';
							html += '</table>';

						} else {
							// No data message
							html += '<p>' + bfwc_params.no_bookings_text + '</p>';
						}
						

						html += '</div>';

					}

					if ( response.booked_day_url != '' ) {
						html += '<br><p>Booked day looks incorrect? <a href="' + response.booked_day_url + '" target="_blank">Check this date\'s meta data</a></p>';
					}

					html += '</div>';

					$( '#bfwc-calendar-modal' ).html( html );

					var timer = setTimeout(
						function() {
							$( 'body' ).find( '.progress-inner' ).each( function() {
								var width = $( this ).attr( 'data-width' );
								$( this ).css( 'width', width + 'px' );
							});
						},
						100
					);
					
				}
			});

			$( 'body' ).on( 'click', '.bfwc-edit-availability', function( e ) {
				e.preventDefault();
				$.ajax({
					type: 'POST',
					url: ajaxurl,
					data: {
						action: 'bfwc_edit_availability',
						date: $( '#bfwc_selected_date' ).val(),
						product_id: $( '#post_ID' ).val(),
						security: $( '#bfwc_calendar_modal_nonce' ).val()
					},
					success: function( response ) {
						// console.log( 'edit availability', response );
					}
				});
			});

		},
		beforeShowDay: function( date ){

			var params = global_calendar.before_show_day( date );
			return params;

		},
		onChangeMonthYear: function( year, month, inst ) {
			$.ajax({
				type: 'POST',
				url: ajaxurl,
				data: {
					action: 'bfwc_get_bookings_by_month_ajax',
					month: month,
					year: year,
					// security: $( '#bfwc_calendar_modal_nonce' ).val()
				},
				success: function( response ) {
					bfwc_monthly_data = response.booking_data;
					global_calendar.update_data();
				}
			});
		}
	});

})(jQuery);
