(function($) {

	$( '#search_start_date' ).datepicker({
		dateFormat: bfwc_search_params.date_format,
		minDate: bfwc_search_params.postpone_start,
		maxDate: bfwc_search_params.last_date,
		firstDay: bfwc_search_params.first_day,
		beforeShow: function( textbox, instance ) {
			$( '#ui-datepicker-div' ).addClass( 'bfwc-search-calendar' );
			setTimeout( function() {
				var input_width = $( '#search_start_date' ).innerWidth();
				instance.dpDiv.css({
					width: input_width + 'px'
				});
			}, 0 );
		},
		beforeShowDay: function(date){
			var is_available = true;
			var dateToday = new Date();
			if( date < dateToday ) {
				is_available = false;
			}
			return [is_available];
		},
		onSelect: function( dateText, inst ) {
			$( this ).change();
			$form = $(this).closest('form');
			var date = $(this).val();

			// Compare start and end dates
			compare_start = $('#search_start_date').datepicker('getDate');

			ymd_start = get_ymd( compare_start );
			$( '#search_start_date_ymd' ).val( ymd_start );

			$('#search_end_date').datepicker({
				dateFormat: bfwc_search_params.date_format,
				minDate: new Date( ymd_start ),
				firstDay: bfwc_search_params.first_day,
				beforeShow: function( textbox, instance ) {
					$( '#ui-datepicker-div' ).addClass( 'bfwc-search-calendar' );
					setTimeout( function() {
						var input_width = $( '#search_end_date' ).innerWidth();
						instance.dpDiv.css({
							width: input_width + 'px'
						});
					}, 0 );
				},
				onSelect: function( dateText, inst ) {
					$( '#search_end_date' ).datepicker( 'option', 'dateFormat', bfwc_search_params.date_format ).val();

					compare_end = $('#search_end_date').datepicker('getDate');
					ymd_end = get_ymd( compare_end );

					$( '#search_end_date_ymd' ).val( ymd_end );

					$( '#bfwc-submit-search' ).prop( 'disabled', false );
				}
			});
			function invalidate_end_date() {
				$( '#search_end_date' ).val( '' );
				$( '#search_end_date_ymd' ).val( '' );
			}
		}
	});

	// Overwrite with English days if no language set
	if( bfwc_search_params.language == 'en' ) {
		$('#search_start_date').datepicker( "option", "dayNamesMin", [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ] );
		$('#search_end_date').datepicker( "option", "dayNamesMin", [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ] );
	}

	function get_ymd( date ) {
		var d = new Date( date );
		var month = '0' + ( d.getMonth() + 1 );
		var day = '0' + ( d.getDate() );
		var ymd_date = d.getFullYear() + '-' + month.substr( -2, 2 ) + '-' + day.substr( -2, 2 );
		return ymd_date;
	}

})(jQuery);
