(function($) {
	var pending_dates;
	$('body').removeClass('booking-cost-set');
	$('#num_units').on( 'change keypress', function(){
		var $form = $(this).closest('form');
		$('.booking-form-inner').addClass('updating');
		$('.single_add_to_cart_button').prop('disabled',true);
		$.ajax({
			type: 'POST',
			url: bfwc_params.ajaxurl,
			data: {
				action: 'bfwc_calculate_booking_cost',
				form: $form.serialize()
			},
			success: function( response ) {
				$('#pending_dates').val(response.dates);
				$('.booking-details-end-date').html(response.end);
				$('.booking-cost').html(bfwc_params.currency_symbol + response.cost);

				$('#calculated_booking_cost').val(response.cost);

				$('#pewc-product-price').val(response.cost);
				$('.single_add_to_cart_button').fadeIn(150);
				$('#bfws-calendar').datepicker('refresh');
				$('.booking-form-inner').removeClass('updating');
				$('.single_add_to_cart_button').prop('disabled',false);
				$( 'body' ).trigger( 'pewc_force_update_total_js' );
			}
		});
	});
	$('#bfws-calendar').datepicker({
		dateFormat: bfwc_params.date_format,
		minDate: 0,
		maxDate: bfwc_params.last_date,
		firstDay: 0,
		dayNamesMin: [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ],
		beforeShowDay: function(date){
			return is_day_available( date, bfwc_params.bookings_start, bfwc_params.last_date, 0, false );
		},
		onSelect: function( dateText, inst ) {
			$form = $(this).closest('form');
			$('.booking-form-inner').addClass('updating');
			$('#pending_dates').val('');
			$('#num_units').val('');
			var date = $(this).val();
			$('#start_date').val(date);
			// Find number of available units from this date
			$.ajax({
				type: 'POST',
				url: bfwc_params.ajaxurl,
				data: {
					action: 'bfwc_calculate_available_units',
					date: date,
					form: $form.serialize()
				},
				success: function( response ) {
					$('.bfws-booking-details').fadeIn(150);
					$('.booking-details-start-date').html(response.date);
					$('#num_units').val( bfwc_params.minimum );
					$('#num_units').attr( 'min', bfwc_params.minimum );
					$('#num_units').attr( 'max', bfwc_params.maximum );
					$('#num_units').trigger( 'change' );
					$('.booking-form-inner').removeClass('updating');
				}
			});
			// Display num_units field with max value set - @todo
		}
	});

	var calendar = {

		before_show_day: function( date ) {

			// Use this to return true/false
			var day_availability = true;

			var is_available = calendar.is_day_available( date, bfwc_params.bookings_start, bfwc_params.last_date, 0, false );

			// Disable dates in the past
			day_availability = calendar.is_day_before_today( date );

			var max_bookings = bfwc_params.max_bookings;
			if( ! max_bookings ) max_bookings = 1;

			var ymd = calendar.convert_to_ymd( date );			

			var title = '';
			var class_name = ' ' + is_available[1];
			class_name += ' date-' + ymd;

			if( ! is_available[0] ) {
				class_name += ' unavailable';
				day_availability = false;
			} else if( ! day_availability ) {
				class_name += ' past';
			} else {
				if( bfwc_availability[ymd] || bfwc_availability[ymd] === 0 ) {
					title = bfwc_availability[ymd] + ' ' + bfwc_params.availability_text;
					if( bfwc_availability[ymd] >= max_bookings ) {
						class_name += ' fully-available';
					} else if( bfwc_availability[ymd] == 0 ) {
						// Weekly bookings are slightly different
						// Need to ensure that the last date of a weekly booking is available for the start of a new one
						if( bfwc_params.booking_unit == 'week' && bfwc_params.bookings_unavailable.indexOf( ymd ) == -1 ) {
							// The availability can show 0 but the date might not be present in the bookings_unavailable parameter
							// If this is the case, it's the last day of a weekly booking and therefore is available for the start of a new booking
							class_name += ' fully-available start-new-weekly';			
						} else if( bfwc_params.booking_unit == 'night' && bfwc_params.allow_overlaps == 'yes' && bfwc_params.bookings_unavailable.indexOf( ymd ) == -1 ) {
							// Overlappable overnight bookings are also different
							class_name += ' fully-available overlap';
						} else {
							class_name += ' unavailable';
							day_availability = false;
						}
					} else {
						class_name += ' part-available';
					}
				} else {

					title = bfwc_params.max_bookings + ' ' + bfwc_params.availability_text;
					class_name += ' fully-available';
				}

			}

			return [day_availability, class_name, title];

		},

		convert_to_ymd: function( d ) {
			// Convert date to YYYY-MM-DD format
			var month = '0' + ( d.getMonth() + 1 );
			day = d.getDate();
			var day = '0' + ( day );
			var converted_date = d.getFullYear() + '-' + month.substr( -2, 2 ) + '-' + day.substr( -2, 2 );
			return converted_date;
		},

		/**
		 * @param date				Date
		 * @param permitted_day 	Specific day of the week that can be selected
		 * @param next_date			Start of next booking. Added 1.1.4
		 * @param min_date			Minimum start date for the calendar, formatted like 2018-02-23
		 * @param is_end			true if the end date calendar has triggered
		 */
		is_day_available: function( date, permitted_day, next_date, min_date, is_end ) {

			// Get a date object for the min_date parameter
			if( min_date ) {
				min_date = min_date.split( '-' );
				var min_date_obj = new Date( min_date[0], min_date[1]-1, min_date[2] );
			}

			var pending_dates = $('#pending_dates').val();
			pending_dates = pending_dates.split(',');

			var d = new Date( date );
			var next_d = new Date( next_date );

			if( Date.parse( next_d ) > 0 ) { // Confirm we have a valid date
				if( d > next_d ) {
					return [false, 'booked']; // We can't book through existing or blocked bookings
				}
			}

			// Use valueOf to compare dates
			if( min_date_obj ) {
				if( d.valueOf() == min_date_obj.valueOf() ) {
					// Return true for minimum bookable date
					return [true,''];
				}
			}

			// Convert date to YYYY-MM-DD format
			var month = '0' + ( d.getMonth() + 1 );
			day = d.getDate();
			// If the booking is overnight and overlaps are permitted and we're looking for the end date, push the available date back by one day
			// This addresses a bug where we couldn't allow a booking to finish on the same day another booking started
			if( is_end && bfwc_params.allow_overlaps == 'yes' && bfwc_params.booking_unit == 'night' ) {
				day++;
			}
			var day = '0' + ( day );
			var check_date = d.getFullYear() + '-' + month.substr( -2, 2 ) + '-' + day.substr( -2, 2 );
			// If date is in the pending list
			if( pending_dates ) {
				if( pending_dates.indexOf( check_date ) != -1 ) {
					return [false,'pending'];
				}
			}

			// If date is in the unavailable list
			if( bfwc_params.bookings_unavailable.indexOf( check_date ) != -1 ) {
				return [false,'booked'];
			}

			// If start day is any day
			if( permitted_day == 99 ) {
				return [true,''];
			} else if( ! is_end && permitted_day == d.getDay() ) {
				// If date is start day
				return [true,''];
			} else if( is_end && permitted_day >= d.getDay() ) {
				// Ensure our end days are the same as the start day for weekly bookings
				if( bfwc_params.booking_unit == 'week' && permitted_day != d.getDay() ) {
					return [false, ''];
				}
				// If date is end day
				return [true,''];
			}
			return [false, 'disabled'];
		},

		convert_to_ymd: function( date ) {
			var d = new Date( date );
			var month = '0' + ( d.getMonth() + 1 );
			var day = '0' + ( d.getDate() );
			var ymd_date = d.getFullYear() + '-' + month.substr( -2, 2 ) + '-' + day.substr( -2, 2 );
			return ymd_date;
		},

		get_date_price: function( date ) {
			if( bfwc_params.booking_unit == 'week' ) {
				return false;
			}
			var prices = bfwc_params.prices;
			if( ! prices[date] ) {
				return bfwc_params.std_cost;
			}
			return prices[date];
		},

		is_day_before_today: function( date ) {

			// Use valueOf to compare dates
			var today = new Date();
			today.setHours( 0, 0, 0, 0 );
			var day = new Date( date );
			day.setHours( 23, 59, 59, 999 );

			if( day.valueOf() < today.valueOf() ) {
				// date is not before today
				return false;
			} else {
				return true;
			}

		},

	};

	$('.bfws-start-date').datepicker({
		dateFormat: bfwc_params.date_format,
		minDate: bfwc_params.postpone_start,
		maxDate: bfwc_params.last_date,
		firstDay: bfwc_params.first_day,
		// dayNamesMin: [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ],
		beforeShowDay: function( date ) {
			var params = calendar.before_show_day( date );
			return params;
		},
		onSelect: function( dateText, inst ) {
			$( this ).change();
			$form = $(this).closest('form');
			// $('.booking-form-inner').addClass('updating');
			$( '.booking-form-inner' ).block( {
				message: null,
				overlayCSS: {
					background: '#fff',
					opacity: 0.6
				}
			});
			$('#pending_dates').val('');
			$('#num_units').val('');
			var date = $(this).val();
			$('#start_date').val(date);
			// Compare start and end dates
			compare_start = $('.bfws-start-date').datepicker('getDate');
			compare_end = $('.bfws-end-date').datepicker('getDate');
			ymd_start = calendar.convert_to_ymd( compare_start );
			ymd_end = calendar.convert_to_ymd( compare_end );
			$('#start_date_ymd').val(ymd_start);
			$('#end_date_ymd').val(ymd_end);
			invalidate_end_date();
			// Find number of available units from this date @todo
			$.ajax({
				type: 'POST',
				url: bfwc_params.ajaxurl,
				data: {
					action: 'bfwc_calculate_available_units',
					date: compare_start,
					end: compare_end,
					unavailable: bfwc_params.bookings_unavailable,
					form: $form.serialize()
				},
				error: function( response ) {
					// console.log(response);
				},
				success: function( response ) {
					$('.bfws-end-date').datepicker('destroy');
					if( response.set_end_date === false ) {
						invalidate_end_date();
					} else {
						update_booking_data(response);
					}
					$('.booking-details-start-date').html(response.date); // Can remove?
					$( '.booking-form-inner' ).unblock();

					if( response.max_date && response.max_date < bfwc_params.last_date_ymd ) {
						var max_date = response.max_date;
					} else {
						var max_date = bfwc_params.last_date_ymd; // 2.0.5
					}

					// Set end date automatically?
					if( bfwc_params.auto_set_end == 'yes' ) {
						$( '.bfws-end-date' ).datepicker().val( $('.bfws-start-date').val() ).trigger( 'click' );
						update_cost();
					}

					$('.bfws-end-date').datepicker({
						dateFormat: 'yy-mm-dd',
						minDate: response.min_date,
						maxDate: max_date,
						firstDay: bfwc_params.first_day,
						// dayNamesMin: [ "Su", "Mo", "Tu", "We", "Th", "Fr", "Sa" ],
						beforeShowDay: function( date ) {

							if( typeof bfwc_availability == 'undefined' ) {
								// Just return true / false
								return calendar.is_day_available( date, response.bookings_end, response.next, 0, true );
							}
							// Otherwise, add the number of available units per date
							var is_available = calendar.is_day_available( date, response.bookings_end, response.next, 0, true );

							var class_name = '';
							var ymd = calendar.convert_to_ymd( date );
							var title = '';

							if( ymd == calendar.convert_to_ymd( response.date ) ) {
								class_name += 'start-date';
							}

							if( date < compare_start ) {
								class_name += ' past';
							} else if( is_available[0] ) {
								class_name += is_available[1];
								if( bfwc_availability[ymd] || bfwc_availability[ymd] === 0 ) {
									title = bfwc_availability[ymd] + ' ' + bfwc_params.availability_text;
									if( bfwc_availability[ymd] >= bfwc_params.max_bookings ) {
										class_name += ' fully-available';
									} else if( bfwc_availability[ymd] == 0 ) {
										class_name += ' unavailable';
									} else {
										class_name += ' part-available';
									}
								} else {
									title = bfwc_params.max_bookings + ' ' + bfwc_params.availability_text;
									class_name += ' fully-available';
								}
								
							}
							return [is_available[0], class_name, title];
						},
						beforeShow: function( textbox, instance ) {
							setTimeout( function() {
								var cal_width = $('#ui-datepicker-div').width();
								var input_width = $('.bfws-end-date').innerWidth();
								var adjustment = parseFloat( cal_width ) - parseFloat( input_width );
								instance.dpDiv.css({
									// marginTop:(-textbox.offsetHeight)+'px',
									// left: '513px'
									// right: 0,
									// marginLeft: -adjustment+'px',
									// marginRight: adjustment+'px'
								});
							}, 0);
						},
						onSelect: function( dateText, inst ) {
							update_cost();
							$( 'body' ).trigger( 'bfwc_end_date_on_select', dateText, inst );
						}
					});
					if( ! $('.bfws-end-date').val() ) {
						$('.single_add_to_cart_button').prop('disabled',true);
					}
				}
			});
			$( '#num_bookings' ).on( 'change update', function() {
				update_cost();
			});
			function update_cost() {
				compare_start = $('.bfws-start-date').datepicker('getDate');
				compare_end = $('.bfws-end-date').datepicker('getDate');
				ymd_start = calendar.convert_to_ymd( compare_start );
				ymd_end = calendar.convert_to_ymd( compare_end );
				$('#start_date_ymd').val(ymd_start);
				$('#end_date_ymd').val(ymd_end);
				$form = $('form.cart');
				// $('.booking-form-inner').addClass('updating');
				$( '.booking-form-inner' ).block( {
					message: null,
					overlayCSS: {
						background: '#fff',
						opacity: 0.6
					}
				});
				$('.single_add_to_cart_button').prop('disabled',true);
				$.ajax({
					type: 'POST',
					url: bfwc_params.ajaxurl,
					data: {
						action: 'bfwc_get_booking_cost',
						form: $form.serialize()
					},
					success: function( response ) {
						// @since 1.1.5 - change the format after the end date has been updated
						$('.bfws-end-date').datepicker('option', 'dateFormat', bfwc_params.date_format).val();
						if( typeof bfwc_availability != 'undefined' && response.lowest_availability > 0 ) {
							$( '#num_bookings' ).attr( 'max', response.lowest_availability );
						}
						update_booking_data(response);
					}
				});
			}
			function update_booking_data( response ) {
				var duration_str = '';
				if( response.num_units == 1 ) {
					duration_str = response.num_units + ' ' + bfwc_params.label_single;
				} else if( response.num_units > 1 ) {
					duration_str = response.num_units + ' ' + bfwc_params.label_plural;
				}
				$('#num_units_int').val( response.num_units );
				$('#num_units').html( duration_str );
				if(response.cost) {

					var cost = response.cost;
					var decimals = bfwc_params.wc_decimals;
					var cost_html = bfwc_params.currency_symbol + cost.toFixed( decimals );

				if( parseFloat( response.discounted_amount ) > 0 ) {
					var discounted_amount = parseFloat( response.discounted_amount );
						cost_html += ' <span class="bfwc-discount-amount">(' + bfwc_params.currency_symbol + discounted_amount.toFixed( decimals ) + ' ' + bfwc_params.discount_text + ')</span>';
					}
					$('.booking-cost').html(cost_html);
					$('#calculated_booking_cost').val(response.cost);
					$('#pewc-product-price').val(response.cost);
					$('body').addClass('booking-cost-set');
					$( 'body' ).trigger( 'pewc_force_update_total_js' );
				} else {
					$('body').removeClass('booking-cost-set');
				}
				$('.single_add_to_cart_button').fadeIn(150);
				// $('.booking-form-inner').removeClass('updating');
				$( '.booking-form-inner' ).unblock();
				$('.single_add_to_cart_button').prop('disabled',false);
			}
			function invalidate_end_date() {
				$('.bfws-end-date').val('');
				$('#end_date_ymd').val('');
				$('#num_units_int').val('');
				$('#num_units').html('');
				$('.booking-cost').html('');
				$('#calculated_booking_cost').val('');
				$('.single_add_to_cart_button').prop('disabled',true);
			}
		}
	});

	// Overwrite with English days if no language set
	if( bfwc_params.language == 'en' ) {
		$('.bfws-start-date').datepicker( "option", "dayNamesMin", [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ] );
		$('.bfws-end-date').datepicker( "option", "dayNamesMin", [ 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa' ] );
	}

	$('.change-booking').on('click',function(e){
		e.preventDefault();
		$form = $('.booking-form');
		$.ajax({
			type: 'POST',
			url: bfwc_params.ajaxurl,
			data: {
				action: 'bfwc_change_booking',
				form: $form.serialize()
			},
			success: function( response ) {
				if( response.status == 'removed' ) {
					window.location.href = response.url;
				}
			}
		});
	});

})(jQuery);
