<?php
/**
 * Functions for syncing calendars with external services
 * @since 2.0.0
 * @package Bookings for WooCommerce
 */

// Exit if accessed directly
if( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Do we need to
 * @since 2.0.0
 */
function bfwc_get_sync_calendars( $product_id ) {

	$sync = get_post_meta( $product_id, 'bfwc_sync_calendars', 'no' );
	return $sync;

}

/**
 * When a booking is made, update the calendar
 * @since 2.0.0
 */
function bfwc_sync_calendar_after_booking( $booking_id, $status, $booking_meta, $product_id ) {

	if( bfwc_get_sync_calendars( $product_id ) != 'yes' ) {
		// Don't create a calendar if we're not syncing this product
		return;
	}

	bfwc_create_calendar( $product_id );

}
add_action( 'bfwc_after_create_new_booking', 'bfwc_sync_calendar_after_booking', 10, 4 );
