<?php

/**
 * Returns array of metaboxes
 * @return Array
 * @since 1.0.0
 */
function bfwc_metaboxes() {

	$fields = array(

		array(
			'ID'		=> 'bfwc_product_id',
			'name'		=> 'bfwc_product_id',
			'title'		=> __( 'Product ID', 'bwfc' ),
			'type'		=> 'booking',
			'class'		=> ''
		),

	);

	$fields = apply_filters( 'bfwc_filter_metabox_fields', $fields );

	$notes_fields = array(
		array(
			'ID'		=> 'bfwc_notes',
			'name'		=> 'bfwc_notes',
			'title'		=> __( 'Notes', 'bwfc' ),
			'type'		=> 'bfwc_notes_callback',
			'class'		=> ''
		)
	);

	$order_fields = array(
		array(
			'ID'		=> 'bfwc_booking_details',
			'name'		=> 'bfwc_booking_details',
			'title'		=> __( 'Booking Details', 'bwfc' ),
			'type'		=> 'bfwc_booking_details_callback',
			'class'		=> ''
		),
	);

	$booked_days_fields = array(
		array(
			'ID'		=> 'bfwc_booked_days',
			'name'		=> 'bfwc_booked_days',
			'title'		=> __( 'Booked Meta', 'bwfc' ),
			'type'		=> 'bfwc_booked_meta_callback',
			'class'		=> ''
		),
	);

	$metaboxes = array(
		array(
			'ID'			=> 'bfwc_metabox',
			'title'			=> __( 'Booking Details', 'bfwc' ),
			'callback'		=> 'meta_box_callback',
			'screens'		=> array( 'bfwc_booking' ),
			'context'		=> 'normal',
			'priority'		=> 'default',
			'fields'		=> $fields
		),
		array(
			'ID'			=> 'bfwc_notes_metabox',
			'title'			=> __( 'Booking Notes', 'bfwc' ),
			'callback'		=> 'meta_box_callback',
			'screens'		=> array( 'bfwc_booking' ),
			'context'		=> 'normal',
			'priority'		=> 'default',
			'fields'		=> $notes_fields
		),
		array(
			'ID'			=> 'bfwc_order_metabox',
			'title'			=> __( 'Booking Details', 'bfwc' ),
			'callback'		=> 'meta_box_callback',
			'screens'		=> array( 'shop_order', wc_get_page_screen_id( 'shop-order' ) ),
			'context'		=> 'normal',
			'priority'		=> 'default',
			'fields'		=> $order_fields
		),
		array(
			'ID'			=> 'bfwc_booked_days_metabox',
			'title'			=> __( 'Booked Day Details', 'bfwc' ),
			'callback'		=> 'meta_box_callback',
			'screens'		=> array( 'bfwc_booked_days' ),
			'context'		=> 'normal',
			'priority'		=> 'default',
			'fields'		=> $booked_days_fields
		),
	);

	$metaboxes = apply_filters( 'bfwc_filter_metaboxes', $metaboxes );

	return $metaboxes;

}
