<?php
/**
 * A form for users to search for bookings
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

$start_ymd = ! empty( $_GET['start_ymd'] ) ? $_GET['start_ymd'] : false;
$end_ymd = ! empty( $_GET['end_ymd'] ) ? $_GET['end_ymd'] : false;

if( $start_ymd ) {
	$start = bfwc_format_date( $start_ymd );
} else {
	$start = apply_filters( 'bfwc_filter_check_in_placeholder', __( 'Check in', 'bfwc' ), false );
}
if( $end_ymd ) {
	$end = bfwc_format_date( $end_ymd );
} else {
	$end = apply_filters( 'bfwc_filter_check_out_placeholder', __( 'Check out', 'bfwc' ), false );
} ?>

<form class="booking-search-form" method="post" enctype='multipart/form-data'>

	<div class="booking-search-form-wrapper">

		<div id="bfws-calendar-wrapper">
			<table>
				<tbody>
					<tr>
						<td class="bfws-date-field-wrapper">
							<i class="gg-calendar-dates"></i>
							<input type="text" id="search_start_date" name="search_start_date" value="" placeholder="<?php echo $start; ?>" readonly="readonly" />
							<input type="hidden" id="search_start_date_ymd" name="search_start_date_ymd" value="<?php echo $start_ymd; ?>" />
						</td>
						<td class="bfws-date-field-wrapper">
							<i class="gg-calendar-dates"></i>
							<input type="text" class="" id="search_end_date" name="search_end_date" value="" placeholder="<?php echo $end; ?>" readonly="readonly" />
							<input type="hidden" id="search_end_date_ymd" name="search_end_date_ymd" value="<?php echo $end_ymd; ?>" />
						</td>
						<td class="bfws-date-field-wrapper">
							<?php $classes = apply_filters( 'bfwc_search_submit_classes', array( 'button' ) );
							printf(
								'<input type="submit" class="%s" id="bfwc-submit-search" value="%s" disabled />',
								join( ' ', $classes ),
								apply_filters( 'bfwc_search_submit_text', __( 'Search', 'bfwc' ) )
							); ?>
						</td>
					</tr>
				</tbody>
			</table>
		</div>

	</div><!-- .booking-search-form-wrapper -->

</form>
