<?php
/**
 * Simple product add to cart
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/add-to-cart/simple.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.woocommerce.com/document/template-structure/
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.0.0
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

global $product;

if ( ! $product->is_purchasable() ) {
	return;
}

echo wc_get_stock_html( $product );

if ( $product->is_in_stock() ) : ?>

	<?php do_action( 'woocommerce_before_add_to_cart_form' ); ?>

	<form class="cart booking-form" method="post" enctype='multipart/form-data'>

		<div class="booking-form-wrapper">

			<?php
				/**
				 * @since 2.1.0.
				 */
				do_action( 'woocommerce_before_add_to_cart_button' );

				/**
				 * @since 3.0.0.
				 */
				do_action( 'woocommerce_before_add_to_cart_quantity' );

				/**
				 * @since 3.0.0.
				 */
				do_action( 'woocommerce_after_add_to_cart_quantity' );
			?>

			<input type="hidden" name="product_id" value="<?php echo esc_attr( $product->get_id() ); ?>">
			<button style="display: none;" type="submit" name="add-to-cart" value="<?php echo esc_attr( $product->get_id() ); ?>" class="single_add_to_cart_button button alt"><?php echo apply_filters( 'bfwc_add_to_cart_text', __( 'Book Now', 'bfwc' ) ); ?></button>

			<?php
				/**
				 * @since 2.1.0.
				 */
				do_action( 'woocommerce_after_add_to_cart_button' );
			?>

		</div><!-- .booking-form-wrapper -->

	</form>

	<?php do_action( 'woocommerce_after_add_to_cart_form' ); ?>

<?php endif; ?>
